# Check and create accounts
ZABBIXUSER=${ZABBIXUSER:-zabbix}
ZABBIXGROUP=${ZABBIXGROUP:-zabbix}
ZABBIXUID=${ZABBIXUID:-228}
ZABBIXGID=${ZABBIXGID:-228}

ZABBIXAGENTUSER=${ZABBIXAGENTUSER:-zabbixagent}
ZABBIXAGENTGROUP=${ZABBIXAGENTGROUP:-zabbixagent}
ZABBIXAGENTUID=${ZABBIXAGENTUID:-266}
ZABBIXAGENTGID=${ZABBIXAGENTGID:-266}

if [ "$(grep ^$ZABBIXGROUP: /etc/group)" = "" ] ; then
    groupadd -g $ZABBIXGID $ZABBIXGROUP
fi
if [ "$(grep ^$ZABBIXAGENTGROUP: /etc/group)" = "" ] ; then
    groupadd -g $ZABBIXAGENTGID $ZABBIXAGENTGROUP
fi
if [ "$(grep ^$ZABBIXUSER: /etc/passwd)" = "" ] ; then
    useradd -u $ZABBIXUID -g $ZABBIXGROUP -d /var/lib/zabbix -s /bin/false $ZABBIXUSER
fi
if [ "$(grep ^$ZABBIXAGENTUSER: /etc/passwd)" = "" ] ; then
    useradd -u $ZABBIXAGENTUID -g $ZABBIXAGENTGROUP -G $ZABBIXGROUP -d /dev/null -s /bin/false $ZABBIXAGENTUSER
fi

config() {
  NEW="$1"
  OLD="$(dirname $NEW)/$(basename $NEW .new)"
  # If there's no config file by that name, mv it over:
  if [ ! -r $OLD ]; then
    mv $NEW $OLD
  elif [ "$(cat $OLD | md5sum)" = "$(cat $NEW | md5sum)" ]; then
    # toss the redundant copy
    rm $NEW
  fi
  # Otherwise, we leave the .new copy for the admin to consider...
}

preserve_perms() {
  NEW="$1"
  OLD="$(dirname $NEW)/$(basename $NEW .new)"
  if [ -e $OLD ]; then
    cp -a $OLD ${NEW}.incoming
    cat $NEW > ${NEW}.incoming
    mv ${NEW}.incoming $NEW
  fi
  config $NEW
}

preserve_perms etc/rc.d/rc.zabbix-agentd.new
config etc/zabbix/zabbix_agentd.conf.new
config var/log/zabbix/zabbix_agentd.log.new
rm -f var/log/zabbix/zabbix_agentd.log.new

